

/* External functions */
extern int __main (void);
extern void SystemInit (void);


/* Default interrupt service routines.
 * Defined as weak symbols. Can be redefined in the application.
 */
#define ALIAS(def) __attribute__((weak,alias(#def)))

void Default_IRQHandler (void);

void Reset_Handler (void);
void NMI_Handler (void);
void HardFault_Handler (void);
void MemManage_Handler (void);
void BusFault_Handler (void);
void UsageFault_Handler (void);
void DebugMon_Handler (void);

extern void vPortSVCHandler (void);
extern void xPortPendSVHandler (void);
extern void xPortSysTickHandler (void);

extern void Image$$ARM_LIB_STACK$$ZI$$Limit;

void WAKEUP_0_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_4_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_5_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_6_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_7_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_8_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_9_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_10_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_11_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_4_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_5_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_6_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_7_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_8_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_9_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_10_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_11_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_4_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_5_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_6_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_7_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_8_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_9_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_10_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_11_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER16_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER16_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER32_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER32_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP0_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART_IRQHandler (void) ALIAS(Default_IRQHandler);
void USBIRQ_IRQHandler (void) ALIAS(Default_IRQHandler);
void USBFIQ_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC_IRQHandler (void) ALIAS(Default_IRQHandler);
void WDT_IRQHandler (void) ALIAS(Default_IRQHandler);
void BOD_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT3_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT2_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT1_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT0_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP1_IRQHandler (void) ALIAS(Default_IRQHandler);



/** Vector table.
 */
void (* const vector_table[])(void) __attribute__((section("RESET"))) =
{
    (void(*)(void))&Image$$ARM_LIB_STACK$$ZI$$Limit,
    Reset_Handler,
    NMI_Handler,
    HardFault_Handler,
    MemManage_Handler,
    BusFault_Handler,
    UsageFault_Handler,                     /* -10: Usage Fault */
    0,
    0,
    0,
    0,
    vPortSVCHandler,                        /* -5: Supervisor Call (RTOS) */
    DebugMon_Handler,                       /* -4: Debug Monitor */
    0,
    xPortPendSVHandler,                     /* -2: PendSV (RTOS */
    xPortSysTickHandler,                    /* -1: SysTick (RTOS) */

    WAKEUP_0_0_IRQHandler,                  /* 0: Wakeup PIO0.0 */
    WAKEUP_0_1_IRQHandler,
    WAKEUP_0_2_IRQHandler,
    WAKEUP_0_3_IRQHandler,
    WAKEUP_0_4_IRQHandler,
    WAKEUP_0_5_IRQHandler,
    WAKEUP_0_6_IRQHandler,
    WAKEUP_0_7_IRQHandler,
    WAKEUP_0_8_IRQHandler,
    WAKEUP_0_9_IRQHandler,
    WAKEUP_0_10_IRQHandler,
    WAKEUP_0_11_IRQHandler,                 /* 11: Wakeup PIO0.11 */
    WAKEUP_1_0_IRQHandler,                  /* 12: Wakeup PIO1.0 */
    WAKEUP_1_1_IRQHandler,
    WAKEUP_1_2_IRQHandler,
    WAKEUP_1_3_IRQHandler,
    WAKEUP_1_4_IRQHandler,
    WAKEUP_1_5_IRQHandler,
    WAKEUP_1_6_IRQHandler,
    WAKEUP_1_7_IRQHandler,
    WAKEUP_1_8_IRQHandler,
    WAKEUP_1_9_IRQHandler,
    WAKEUP_1_10_IRQHandler,
    WAKEUP_1_11_IRQHandler,                 /* 23: Wakeup PIO1.11 */
    WAKEUP_2_0_IRQHandler,                  /* 24: Wakeup PIO2.0 */
    WAKEUP_2_1_IRQHandler,
    WAKEUP_2_2_IRQHandler,
    WAKEUP_2_3_IRQHandler,
    WAKEUP_2_4_IRQHandler,
    WAKEUP_2_5_IRQHandler,
    WAKEUP_2_6_IRQHandler,
    WAKEUP_2_7_IRQHandler,
    WAKEUP_2_8_IRQHandler,
    WAKEUP_2_9_IRQHandler,
    WAKEUP_2_10_IRQHandler,
    WAKEUP_2_11_IRQHandler,                 /* 35: Wakeup PIO2.11 */
    WAKEUP_3_0_IRQHandler,                  /* 36: Wakeup PIO3.0 */
    WAKEUP_3_1_IRQHandler,
    WAKEUP_3_2_IRQHandler,
    WAKEUP_3_3_IRQHandler,                  /* 39: Wakeup PIO3.3 */
    I2C_IRQHandler,                         /* 40: I2C */
    TIMER16_0_IRQHandler,
    TIMER16_1_IRQHandler,
    TIMER32_0_IRQHandler,
    TIMER32_1_IRQHandler,
    SSP0_IRQHandler,
    UART_IRQHandler,
    USBIRQ_IRQHandler,
    USBFIQ_IRQHandler,
    ADC_IRQHandler,                         /* 49: A/D Converter */
    WDT_IRQHandler,
    BOD_IRQHandler,
    0,
    PIOINT3_IRQHandler,
    PIOINT2_IRQHandler,
    PIOINT1_IRQHandler,
    PIOINT0_IRQHandler,
    SSP1_IRQHandler,                        /* 57: SSP1 */
};


__attribute__ ((section(".ARM.__at_0x02FC")))
const unsigned long CRP_Key = 0xFFFFFFFF;


void Reset_Handler (void)
{
    SystemInit();   /* Globals not yet initialized!! */

    /* Jump to the library entry point __main() */
    __main();

    /* Loop here forever, in case main() ever returns. */
    while (1) {
    }
}




void NMI_Handler (void)
{
    while (1)
        ;
}

void HardFault_Handler (void)
{
    while (1)
        ;
}

void MemManage_Handler (void)
{
    while (1)
        ;
}

void BusFault_Handler (void)
{
    while (1)
        ;
}

void UsageFault_Handler (void)
{
    while (1)
        ;
}

void DebugMon_Handler (void)
{
    while (1)
        ;
}

void Default_IRQHandler (void)
{
    while (1)
        ;
}

