
#include <stdint.h>


/* External functions */
extern int main (void);
extern void SystemInit (void);

/* These section descriptors are defined in the linker script */
extern uint32_t __stack_end__;
extern uint32_t __bss_start__;
extern uint32_t __bss_end__;
extern uint32_t __data_start__;
extern uint32_t __data_end__;
extern uint32_t __end_of_text__;
extern uint32_t __newlib_heap_start__;



/* Default interrupt service routines.
 * Defined as weak symbols. Can be redefined in the application.
 */
#define ALIAS(def) __attribute__((weak,alias(#def)))

void Default_IRQHandler( void );

void Reset_Handler( void );
void NMI_Handler( void );
void HardFault_Handler( void );
void MPU_Handler( void );
void BusFault_Handler( void );
void UsageFault_Handler( void );

extern void vPortSVCHandler (void);
extern void xPortPendSVHandler (void);
extern void xPortSysTickHandler (void);


void WAKEUP_0_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_4_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_5_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_6_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_7_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_8_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_9_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_10_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_0_11_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_4_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_5_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_6_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_7_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_8_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_9_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_10_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_1_11_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_4_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_5_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_6_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_7_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_8_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_9_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_10_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_2_11_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_2_IRQHandler (void) ALIAS(Default_IRQHandler);
void WAKEUP_3_3_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER16_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER16_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER32_0_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER32_1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP0_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART_IRQHandler (void) ALIAS(Default_IRQHandler);
void USBIRQ_IRQHandler (void) ALIAS(Default_IRQHandler);
void USBFIQ_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC_IRQHandler (void) ALIAS(Default_IRQHandler);
void WDT_IRQHandler (void) ALIAS(Default_IRQHandler);
void BOD_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT3_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT2_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT1_IRQHandler (void) ALIAS(Default_IRQHandler);
void PIOINT0_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP1_IRQHandler (void) ALIAS(Default_IRQHandler);



/**
 * Vector table
 */
void (*vector_table[])( void ) __attribute__ ((section(".vectors"))) =
{
    (void(*)(void))&__stack_end__,
    Reset_Handler,
    NMI_Handler,
    HardFault_Handler,
    MPU_Handler,
    BusFault_Handler,
    UsageFault_Handler,
    0,
    0,
    0,
    0,
    vPortSVCHandler,
    0,
    0,
    xPortPendSVHandler,
    xPortSysTickHandler,

    WAKEUP_0_0_IRQHandler,                  /* #(16 + 0) */
    WAKEUP_0_1_IRQHandler,
    WAKEUP_0_2_IRQHandler,
    WAKEUP_0_3_IRQHandler,
    WAKEUP_0_4_IRQHandler,
    WAKEUP_0_5_IRQHandler,
    WAKEUP_0_6_IRQHandler,
    WAKEUP_0_7_IRQHandler,
    WAKEUP_0_8_IRQHandler,
    WAKEUP_0_9_IRQHandler,
    WAKEUP_0_10_IRQHandler,
    WAKEUP_0_11_IRQHandler,
    WAKEUP_1_0_IRQHandler,
    WAKEUP_1_1_IRQHandler,
    WAKEUP_1_2_IRQHandler,
    WAKEUP_1_3_IRQHandler,
    WAKEUP_1_4_IRQHandler,
    WAKEUP_1_5_IRQHandler,
    WAKEUP_1_6_IRQHandler,
    WAKEUP_1_7_IRQHandler,
    WAKEUP_1_8_IRQHandler,
    WAKEUP_1_9_IRQHandler,
    WAKEUP_1_10_IRQHandler,
    WAKEUP_1_11_IRQHandler,
    WAKEUP_2_0_IRQHandler,
    WAKEUP_2_1_IRQHandler,
    WAKEUP_2_2_IRQHandler,
    WAKEUP_2_3_IRQHandler,
    WAKEUP_2_4_IRQHandler,
    WAKEUP_2_5_IRQHandler,
    WAKEUP_2_6_IRQHandler,
    WAKEUP_2_7_IRQHandler,
    WAKEUP_2_8_IRQHandler,
    WAKEUP_2_9_IRQHandler,
    WAKEUP_2_10_IRQHandler,
    WAKEUP_2_11_IRQHandler,
    WAKEUP_3_0_IRQHandler,
    WAKEUP_3_1_IRQHandler,
    WAKEUP_3_2_IRQHandler,
    WAKEUP_3_3_IRQHandler,                  /* #(16 + 39) */

    I2C_IRQHandler,                         /* #(16 + 40) */
    TIMER16_0_IRQHandler,
    TIMER16_1_IRQHandler,
    TIMER32_0_IRQHandler,
    TIMER32_1_IRQHandler,
    SSP0_IRQHandler,
    UART_IRQHandler,
    USBIRQ_IRQHandler,
    USBFIQ_IRQHandler,
    ADC_IRQHandler,
    WDT_IRQHandler,
    BOD_IRQHandler,
    0,
    PIOINT3_IRQHandler,
    PIOINT2_IRQHandler,
    PIOINT1_IRQHandler,
    PIOINT0_IRQHandler,
    SSP1_IRQHandler,                        /* #(16 + 57) */
};




uint32_t *pRam __attribute__((section(".pRam")));
uint32_t *pRom;


void Reset_Handler (void)
{
    /* Initialize data segments with the initializers from flash.
     * data is in the 'main' RAM block, starting at address 0x10000000.
     */
    pRom = &__end_of_text__;
    for (pRam = &__data_start__; pRam < &__data_end__; pRam++) {
        *pRam = *pRom++;
    }

    /* Clear the bss sections in RAM.
     * bss is in the 'main' RAM block, starting at address 0x10000000.
     */
    for (pRam = &__bss_start__; pRam < &__bss_end__; pRam++) {
        *pRam = 0;
    }

#if 1
    /* Fill the heap and stack with a marker */
    for (pRam = &__newlib_heap_start__; pRam < &__stack_end__; pRam++) {
        *pRam = 0xE5E5E5E5;
    }
#endif

    SystemInit();   /* Globals not yet initialized!! */

    /* Now we can jump to the application entry point main() */
    main();

    /* Loop here forever, in case main() ever returns. */
    while (1) {
    }
}



/*------ Core exception handlers --------------------------------------------*/

void NMI_Handler (void)
{
    while (1) {
    }
}


void HardFault_Handler (void)
{
    while (1) {
    }
}


void MPU_Handler (void)
{
    while (1) {
    }
}


void BusFault_Handler (void)
{
    while (1) {
    }
}


void UsageFault_Handler (void)
{
    while (1) {
    }
}


/*------ Default IRQ handler ------------------------------------------------*/

void Default_IRQHandler (void)
{
    while (1) {
    }
}

