
#include <stdint.h>


/* External functions */
extern int main (void);
extern void SystemInit (void);

/* These section descriptors are defined in the linker script */
extern uint32_t __stack_end__;
extern uint32_t __bss_start__;
extern uint32_t __bss_end__;
extern uint32_t __bss2_start__;
extern uint32_t __bss2_end__;
extern uint32_t __bss3_start__;
extern uint32_t __bss3_end__;
extern uint32_t __data_start__;
extern uint32_t __data_end__;
extern uint32_t __data2_start__;
extern uint32_t __data2_end__;
extern uint32_t __data3_start__;
extern uint32_t __data3_end__;
extern uint32_t __end_of_text__;



/* Default interrupt service routines.
 * Defined as weak symbols. Can be redefined in the application.
 */
#define ALIAS(def) __attribute__((weak,alias(#def)))

void Default_IRQHandler (void);

void Reset_Handler (void);
void NMI_Handler (void);
void HardFault_Handler (void);
void MPU_Handler (void);
void BusFault_Handler (void);
void UsageFault_Handler (void);

extern void vPortSVCHandler (void);
extern void xPortPendSVHandler (void);
extern void xPortSysTickHandler (void);


void DAC_IRQHandler (void) ALIAS(Default_IRQHandler);
void M0_IRQHandler (void) ALIAS(Default_IRQHandler);
void DMA_IRQHandler (void) ALIAS(Default_IRQHandler);
void FLASH_EEPROM_IRQHandler (void) ALIAS(Default_IRQHandler);
void ETH_IRQHandler (void) ALIAS(Default_IRQHandler);
void SDIO_IRQHandler (void) ALIAS(Default_IRQHandler);
void LCD_IRQHandler (void) ALIAS(Default_IRQHandler);
void USB0_IRQHandler (void) ALIAS(Default_IRQHandler);
void USB1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SCT_IRQHandler (void) ALIAS(Default_IRQHandler);
void RIT_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER0_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER1_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER2_IRQHandler (void) ALIAS(Default_IRQHandler);
void TIMER3_IRQHandler (void) ALIAS(Default_IRQHandler);
void MCPWM_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2C1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SPI_IRQHandler (void) ALIAS(Default_IRQHandler);
void ADC1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP0_IRQHandler (void) ALIAS(Default_IRQHandler);
void SSP1_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART0_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART1_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART2_IRQHandler (void) ALIAS(Default_IRQHandler);
void UART3_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2S0_IRQHandler (void) ALIAS(Default_IRQHandler);
void I2S1_IRQHandler (void) ALIAS(Default_IRQHandler);
void SPIFI_IRQHandler (void) ALIAS(Default_IRQHandler);
void SGPIO_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO0_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO1_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO2_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO3_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO4_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO5_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO6_IRQHandler (void) ALIAS(Default_IRQHandler);
void GPIO7_IRQHandler (void) ALIAS(Default_IRQHandler);
void GINT0_IRQHandler (void) ALIAS(Default_IRQHandler);
void GINT1_IRQHandler (void) ALIAS(Default_IRQHandler);
void EVRT_IRQHandler (void) ALIAS(Default_IRQHandler);
void CAN1_IRQHandler (void) ALIAS(Default_IRQHandler);
void VADC_IRQHandler (void) ALIAS(Default_IRQHandler);
void ATIMER_IRQHandler (void) ALIAS(Default_IRQHandler);
void RTC_IRQHandler (void) ALIAS(Default_IRQHandler);
void WDT_IRQHandler (void) ALIAS(Default_IRQHandler);
void CAN0_IRQHandler (void) ALIAS(Default_IRQHandler);
void QEI_IRQHandler (void) ALIAS(Default_IRQHandler);



/** Vector table. */
void (*vector_table[])( void ) __attribute__ ((section(".vectors"))) =
{
    (void(*)(void))&__stack_end__,
    Reset_Handler,
    NMI_Handler,
    HardFault_Handler,
    MPU_Handler,
    BusFault_Handler,
    UsageFault_Handler,
    0,
    0,
    0,
    0,
    vPortSVCHandler,
    0,
    0,
    xPortPendSVHandler,                     /* -2 */
    xPortSysTickHandler,                    /* -1 */

    DAC_IRQHandler,                         /* 0 */
    M0_IRQHandler,                          /* 1 */
    DMA_IRQHandler,                         /* 2 */
    0,
    FLASH_EEPROM_IRQHandler,                /* 4 */
    ETH_IRQHandler,                         /* 5 */
    SDIO_IRQHandler,                        /* 6 */
    LCD_IRQHandler,                         /* 7 */
    USB0_IRQHandler,                        /* 8 */
    USB1_IRQHandler,                        /* 9 */
    SCT_IRQHandler,                         /* 10 */
    RIT_IRQHandler,                         /* 11 */
    TIMER0_IRQHandler,                      /* 12 */
    TIMER1_IRQHandler,                      /* 13 */
    TIMER2_IRQHandler,                      /* 14 */
    TIMER3_IRQHandler,                      /* 15 */
    MCPWM_IRQHandler,                       /* 16 */
    ADC0_IRQHandler,                        /* 17 */
    I2C0_IRQHandler,                        /* 18 */
    I2C1_IRQHandler,                        /* 19 */
    SPI_IRQHandler,                         /* 20 */
    ADC1_IRQHandler,                        /* 21 */
    SSP0_IRQHandler,                        /* 22 */
    SSP1_IRQHandler,                        /* 23 */
    UART0_IRQHandler,                       /* 24 */
    UART1_IRQHandler,                       /* 25 */
    UART2_IRQHandler,                       /* 26 */
    UART3_IRQHandler,                       /* 27 */
    I2S0_IRQHandler,                        /* 28 */
    I2S1_IRQHandler,                        /* 29 */
    SPIFI_IRQHandler,                       /* 30 */
    SGPIO_IRQHandler,                       /* 31 */
    GPIO0_IRQHandler,                       /* 32 */
    GPIO1_IRQHandler,                       /* 33 */
    GPIO2_IRQHandler,                       /* 34 */
    GPIO3_IRQHandler,                       /* 35 */
    GPIO4_IRQHandler,                       /* 36 */
    GPIO5_IRQHandler,                       /* 37 */
    GPIO6_IRQHandler,                       /* 38 */
    GPIO7_IRQHandler,                       /* 39 */
    GINT0_IRQHandler,                       /* 40 */
    GINT1_IRQHandler,                       /* 41 */
    EVRT_IRQHandler,                        /* 42 */
    CAN1_IRQHandler,                        /* 43 */
    0,
    VADC_IRQHandler,                        /* 45 */
    ATIMER_IRQHandler,                      /* 46 */
    RTC_IRQHandler,                         /* 47 */
    0,
    WDT_IRQHandler,                         /* 49 */
    0,
    CAN0_IRQHandler,                        /* 51 */
    QEI_IRQHandler,                         /* 52 */
};




uint32_t *pRam __attribute__((section(".pRam")));
uint32_t *pRom;



void Reset_Handler( void )
{
    /* Init the clock tree */
    SystemInit();

    /* Initialize data segments with the initializers from flash.
     * data is in the 'main' RAM block, starting at address 0x10000000.
     * data2 and data3 are located in the two other 16 KiB RAM blocks
     * at 0x2007C000 and 0x20080000 (64 KiB parts).
     */
    pRom = (uint32_t *)&__end_of_text__;
    for (pRam = &__data_start__; pRam < &__data_end__; pRam++) {
        *pRam = *pRom++;
    }
    for (pRam = &__data2_start__; pRam < &__data2_end__; pRam++) {
        *pRam = *pRom++;
    }
    for (pRam = &__data3_start__; pRam < &__data3_end__; pRam++) {
        *pRam = *pRom++;
    }

    /* Clear the bss sections in RAM.
     * bss is in the 'main' RAM block, starting at address 0x10000000.
     * bss2 and bss3 are located in the two other 16 KiB RAM blocks
     * at 0x2007C000 and 0x20080000 (64 KiB parts).
     */
    for (pRam = &__bss_start__; pRam < &__bss_end__; pRam++) {
        *pRam = 0;
    }
    for (pRam = &__bss2_start__; pRam < &__bss2_end__; pRam++) {
        *pRam = 0;
    }
    for (pRam = &__bss3_start__; pRam < &__bss3_end__; pRam++) {
        *pRam = 0;
    }

    /* Now we can jump to the application entry point main() */
    main();

    /* Loop here forever, in case main() ever returns. */
    while (1) {
    }
}



/*------ Core exception handlers --------------------------------------------*/

void NMI_Handler (void)
{
    while (1) {
    }
}


void HardFault_Handler (void)
{
    while (1) {
    }
}


void MPU_Handler (void)
{
    while (1) {
    }
}


void BusFault_Handler (void)
{
    while (1) {
    }
}


void UsageFault_Handler (void)
{
    while (1) {
    }
}


/*------ Default IRQ handler ------------------------------------------------*/

void Default_IRQHandler (void)
{
    while (1) {
    }
}

